

 void cfg_rcc(void)
 {
  RCC->AHBENR  |= RCC_AHBENR_GPIOAEN | RCC_AHBENR_GPIOBEN | RCC_AHBENR_GPIOFEN;
  RCC->AHBENR  |= RCC_AHBENR_DMA1EN;

  RCC->APB1ENR |= RCC_APB1ENR_TIM14EN;
  RCC->APB2ENR |= RCC_APB2ENR_TIM1EN;
 }

 void cfg_gpio(void)
 {
  GPIO_InitTypeDef GIS;

  GIS.GPIO_Speed = GPIO_Speed_2MHz;

 //PF1,PF0 - reset pullup
  GIS.GPIO_Pin   = GPIO_Pin_0|GPIO_Pin_1;
  GIS.GPIO_Mode  = GPIO_Mode_AN;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_UP;

  GPIO_Init(GPIOF, &GIS);

 //PA0 - digital input for btn
  GIS.GPIO_Pin   = GPIO_Pin_0;
  GIS.GPIO_Mode  = GPIO_Mode_IN;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_UP;

  GPIO_Init(GPIOA, &GIS);

 //PA1, PA2 - analog input for adc
  GIS.GPIO_Pin   = GPIO_Pin_1|GPIO_Pin_2;
  GIS.GPIO_Mode  = GPIO_Mode_AN;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_NOPULL;

  GPIO_Init(GPIOA, &GIS);

  //PA3,PA4,PA5,PA6 - output
  GIS.GPIO_Pin   = GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6;
  GIS.GPIO_Mode  = GPIO_Mode_OUT;
  GIS.GPIO_OType = GPIO_OType_PP;
  GIS.GPIO_PuPd  = GPIO_PuPd_NOPULL;

  GPIO_Init(GPIOA, &GIS);

  //PA7 - timer_14 output
  GIS.GPIO_Pin   = GPIO_Pin_7;
  GIS.GPIO_Mode  = GPIO_Mode_AF;
  GIS.GPIO_OType = GPIO_OType_PP;
  GIS.GPIO_PuPd  = GPIO_PuPd_NOPULL;

  GPIO_Init(GPIOA, &GIS);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource7, GPIO_AF_4);

  //PB1 - output
  GIS.GPIO_Pin   = GPIO_Pin_1;
  GIS.GPIO_Mode  = GPIO_Mode_OUT;
  GIS.GPIO_OType = GPIO_OType_PP;
  GIS.GPIO_PuPd  = GPIO_PuPd_NOPULL;

  GPIO_Init(GPIOB, &GIS);

  //PA9,PA10 - timer_1 output
  GIS.GPIO_Pin   = GPIO_Pin_9|GPIO_Pin_10;
  GIS.GPIO_Mode  = GPIO_Mode_AF;
  GIS.GPIO_OType = GPIO_OType_PP;
  GIS.GPIO_PuPd  = GPIO_PuPd_NOPULL;

  GPIO_Init(GPIOA, &GIS);
  GPIOA->BSRR = 1<<9|1<<10;

  GPIO_PinAFConfig(GPIOA, GPIO_PinSource9,  GPIO_AF_2);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_2);
 }

 void cfg_systic(int frq)
 {
  SysTick->LOAD  = SYSTEM_FRQ/frq-1;
  NVIC_SetPriority (SysTick_IRQn, 3);
  SysTick->CTRL  = SysTick_CTRL_CLKSOURCE_Msk|SysTick_CTRL_TICKINT_Msk|SysTick_CTRL_ENABLE_Msk;
 }

 void cfg_t1(int p_top)
 {
  TIM1->PSC   = 0;
  TIM1->ARR   = p_top;

  TIM1->CR2   = TIM_CR2_OIS2|TIM_CR2_OIS3;

  TIM1->CCMR1 = (u32)6<<12; //pwm1 on cnl2
  TIM1->CCMR2 = (u32)7<<4;  //pwm2 on cnl3
  TIM1->CCER  = TIM_CCER_CC2E|TIM_CCER_CC3E;

  TIM1->DIER  = TIM_DIER_UDE;

                //2 transferts burst
  TIM1->DCR   = 1<<8 |
                //offset from CR1
                ((u32)&TIM1->CCR2 - (u32)&TIM1->CR1)/sizeof(u32);

  TIM1->BDTR  = TIM_BDTR_OSSI|3<<8;  //lock level 3

  TIM1->SR    = 0;
  TIM1->EGR   = TIM_EGR_UG;
 }

 void cfg_dma_t1(void)
 {
  DMA1_Channel5->CPAR  = (uint32_t)&TIM1->DMAR;
  DMA1_Channel5->CNDTR = 1;
  DMA1_Channel5->CCR   = DMA_CCR_MINC    | //memory incremental mode
                         DMA_CCR_CIRC    | //circular mode
                         DMA_CCR_MSIZE_0 | //16 bit
                         DMA_CCR_PSIZE_0 | //16 bit
                         DMA_CCR_PL      | //vh priority
                         DMA_CCR_DIR     | //read from memory
                         DMA_CCR_EN;
 }


//0x9f vdda_off parity_on, 0xdf vdda_off, 0xbf ram parity checking on
FLASH_Status FLASH_OB_UBC(uint8_t input_val)
{
  FLASH_Status status = FLASH_COMPLETE;

  if((OB->USER & 0xff) != input_val)
  {
   /* Wait for last operation to be completed */
   status = FLASH_WaitForLastOperation(FLASH_ER_PRG_TIMEOUT);

   if(status == FLASH_COMPLETE)
   {
    __disable_interrupt();
    FLASH_Unlock();
    FLASH_OB_Unlock();

    uint8_t tmp_mss[sizeof(*OB)/sizeof(uint16_t)];
    uint16_t *pt = (uint16_t *)OB;

    for(int i=0; i<sizeof(*OB)/sizeof(uint16_t);i++) tmp_mss[i] = uint8_t(*pt++);

     FLASH->CR |= FLASH_CR_OPTER;
     FLASH->CR |= FLASH_CR_STRT;

     while((FLASH_WaitForLastOperation(FLASH_ER_PRG_TIMEOUT)==FLASH_BUSY))__no_operation();

     FLASH->CR &= ~FLASH_CR_OPTER;
     FLASH->CR |= FLASH_CR_OPTPG;

     OB->USER = input_val;
     while((FLASH_WaitForLastOperation(FLASH_ER_PRG_TIMEOUT)==FLASH_BUSY))__no_operation();

     pt = (uint16_t *)OB;

     for(int i=0; i<sizeof(*OB)/sizeof(uint16_t);i++)
     {
      *(pt+i) = tmp_mss[i];

      if(i==((uint16_t *)&OB->USER -(uint16_t *)OB))i++;

      while((FLASH_WaitForLastOperation(FLASH_ER_PRG_TIMEOUT)==FLASH_BUSY))__no_operation();
     }

     /* Wait for last operation to be completed */
     status = FLASH_WaitForLastOperation(FLASH_ER_PRG_TIMEOUT);

     if(status != FLASH_TIMEOUT)
     {
       /* if the program operation is completed, disable the OPTPG Bit */
       FLASH->CR &= ~FLASH_CR_OPTPG;
       FLASH_OB_Lock();
       FLASH_Lock();

       FLASH_OB_Launch();
     }
   }
  }
  /* Return the Option Byte program Status */
  return status;
}








